
<!DOCTYPE html>

<html>
  <head>
    <meta charset="utf-8" />
    <meta name="viewport" content="width=device-width, initial-scale=1.0" />
    <title>Tarascon’s Coin dataset &#8212; Battery SOH  documentation</title>
    
  <link href="../_static/css/theme.css" rel="stylesheet" />
  <link href="../_static/css/index.c5995385ac14fb8791e8eb36b4908be2.css" rel="stylesheet" />

    
  <link rel="stylesheet"
    href="../_static/vendor/fontawesome/5.13.0/css/all.min.css">
  <link rel="preload" as="font" type="font/woff2" crossorigin
    href="../_static/vendor/fontawesome/5.13.0/webfonts/fa-solid-900.woff2">
  <link rel="preload" as="font" type="font/woff2" crossorigin
    href="../_static/vendor/fontawesome/5.13.0/webfonts/fa-brands-400.woff2">

    
      

    
    <link rel="stylesheet" type="text/css" href="../_static/pygments.css" />
    <link rel="stylesheet" type="text/css" href="../_static/basic.css" />
    <link rel="stylesheet" type="text/css" href="../_static/css/custom.css" />
    
  <link rel="preload" as="script" href="../_static/js/index.1c5a1a01449ed65a7b51.js">

    <script data-url_root="../" id="documentation_options" src="../_static/documentation_options.js"></script>
    <script src="../_static/jquery.js"></script>
    <script src="../_static/underscore.js"></script>
    <script src="../_static/doctools.js"></script>
    <script crossorigin="anonymous" integrity="sha256-Ae2Vz/4ePdIu6ZyI/5ZGsYnb+m0JlOmKPjt6XZ9JJkA=" src="https://cdnjs.cloudflare.com/ajax/libs/require.js/2.3.4/require.min.js"></script>
    <script async="async" src="https://cdn.jsdelivr.net/npm/mathjax@3/es5/tex-mml-chtml.js"></script>
    <script>window.MathJax = {"tex": {"inlineMath": [["$", "$"], ["\\(", "\\)"]], "processEscapes": true}, "options": {"ignoreHtmlClass": "tex2jax_ignore|mathjax_ignore|document", "processHtmlClass": "tex2jax_process|mathjax_process|math|output_area"}}</script>
    <link rel="index" title="Index" href="../genindex.html" />
    <link rel="search" title="Search" href="../search.html" />
    <link rel="next" title="Treatment functions" href="Cleaning.html" />
    <link rel="prev" title="MIT dataset" href="MIT.html" />
    <meta name="viewport" content="width=device-width, initial-scale=1" />
    <meta name="docsearch:language" content="en" />
    
  </head>
  <body data-spy="scroll" data-target="#bd-toc-nav" data-offset="80">
    
    <div class="container-fluid" id="banner"></div>

    
    <nav class="navbar navbar-light navbar-expand-lg bg-light fixed-top bd-navbar" id="navbar-main"><div class="container-xl">

  <div id="navbar-start">
    
    

<a class="navbar-brand" href="../index.html">
  <img src="../_static/logo.png" class="logo" alt="logo">
</a>


    
  </div>

  <button class="navbar-toggler" type="button" data-toggle="collapse" data-target="#navbar-collapsible" aria-controls="navbar-collapsible" aria-expanded="false" aria-label="Toggle navigation">
    <span class="navbar-toggler-icon"></span>
  </button>

  
  <div id="navbar-collapsible" class="col-lg-9 collapse navbar-collapse">
    <div id="navbar-center" class="mr-auto">
      
      <div class="navbar-center-item">
        <ul id="navbar-main-elements" class="navbar-nav">
    <li class="toctree-l1 nav-item">
 <a class="reference internal nav-link" href="Colabs.html">
  Google Colabs
 </a>
</li>

<li class="toctree-l1 nav-item">
 <a class="reference internal nav-link" href="main.html">
  Useful dictionaries
 </a>
</li>

<li class="toctree-l1 current active nav-item">
 <a class="reference internal nav-link" href="Battery%20Classes.html">
  Battery Classes
 </a>
</li>

<li class="toctree-l1 nav-item">
 <a class="reference internal nav-link" href="Cleaning.html">
  Treatment functions
 </a>
</li>

<li class="toctree-l1 nav-item">
 <a class="reference internal nav-link" href="Models.html">
  Models
 </a>
</li>

<li class="toctree-l1 nav-item">
 <a class="reference internal nav-link" href="Training.html">
  Training and Simulation
 </a>
</li>

<li class="toctree-l1 nav-item">
 <a class="reference internal nav-link" href="Report.html">
  Report related
 </a>
</li>

    
</ul>
      </div>
      
    </div>

    <div id="navbar-end">
      
      <div class="navbar-end-item">
        <ul id="navbar-icon-links" class="navbar-nav" aria-label="Icon Links">
      </ul>
      </div>
      
    </div>
  </div>
</div>
    </nav>
    

    <div class="container-xl">
      <div class="row">
          
            
            <!-- Only show if we have sidebars configured, else just a small margin  -->
            <div class="col-12 col-md-3 bd-sidebar"><form class="bd-search d-flex align-items-center" action="../search.html" method="get">
  <i class="icon fas fa-search"></i>
  <input type="search" class="form-control" name="q" id="search-input" placeholder="Search the docs ..." aria-label="Search the docs ..." autocomplete="off" >
</form><nav class="bd-links" id="bd-docs-nav" aria-label="Main navigation">
  <div class="bd-toc-item active">
    <ul class="current nav bd-sidenav">
 <li class="toctree-l1">
  <a class="reference internal" href="NASA.html">
   Nasa dataset
  </a>
 </li>
 <li class="toctree-l1">
  <a class="reference internal" href="MIT.html">
   MIT dataset
  </a>
 </li>
 <li class="toctree-l1 current active">
  <a class="current reference internal" href="#">
   Tarascon's Coin dataset
  </a>
 </li>
</ul>

  </div>
</nav>
            </div>
            
          

          
          <div class="d-none d-xl-block col-xl-2 bd-toc">
            
              
              <div class="toc-item">
                
<div class="tocsection onthispage pt-5 pb-3">
    <i class="fas fa-list"></i> On this page
</div>

<nav id="bd-toc-nav">
    <ul class="visible nav section-nav flex-column">
 <li class="toc-h2 nav-item toc-entry">
  <a class="reference internal nav-link" href="#classes-for-storing-the-raw-data">
   Classes for storing the raw data
  </a>
 </li>
 <li class="toc-h2 nav-item toc-entry">
  <a class="reference internal nav-link" href="#classes-for-cleaning-and-storing-cleaned-data">
   Classes for cleaning and storing cleaned data
  </a>
 </li>
</ul>

</nav>
              </div>
              
              <div class="toc-item">
                
              </div>
              
            
          </div>
          

          
          
            
          
          <main class="col-12 col-md-9 col-xl-7 py-md-5 pl-md-5 pr-md-4 bd-content" role="main">
              
              <div>
                
  <div class="section" id="tarascon-s-coin-dataset">
<h1>Tarascon’s Coin dataset<a class="headerlink" href="#tarascon-s-coin-dataset" title="Permalink to this headline">¶</a></h1>
<p>Corresponds to the <code class="docutils literal notranslate"><span class="pre">Coin_Classes</span></code> module.</p>
<p>Path for the clean batteries:
“Datasets/Tarascon/Coins/Clean_Batteries”
or simply <code class="docutils literal notranslate"><span class="pre">import</span> <span class="pre">main</span></code> and do <code class="docutils literal notranslate"><span class="pre">main.path_dict['Tarascon</span> <span class="pre">Coin']</span></code></p>
<p>Batteries are charged at C/5 until the voltage reaches 4,3V. The value of
<span class="math notranslate nohighlight">\(Q_nominal\)</span> varies slightly for each battery because the electrode mass
used also varies slightly (as well as other chemistry details).
Because of this, we work with specific <span class="math notranslate nohighlight">\(Q\)</span> values.
The capacity value saved in the <code class="xref py py-class docutils literal notranslate"><span class="pre">Coin_Data</span></code> class
(Coin_Data.capacity) is already normalized by the mass (A.h/mg). A value of
0.1284 A.h/mg is used for the nominal specific capacity for calculating SOH.
The <code class="docutils literal notranslate"><span class="pre">C_rate</span></code> used for nondimensioning the current in the
<a class="reference internal" href="LSTM.html#LSTM.Torch_Dataset_LSTM" title="LSTM.Torch_Dataset_LSTM"><code class="xref py py-class docutils literal notranslate"><span class="pre">LSTM.Torch_Dataset_LSTM</span></code></a> class is also updated according to the mass for
each battery.</p>
<p>You can check extensive information in the “Information regarding cells.xlsx”
spreadsheet found with the raw dataset files.</p>
<p>Tarascon’s Coin dataset is structurally different from the others.
Each numbered battery has a different number of independent cells
(which are just duplicates/triplicates etc., separate cells that go through the’
exact same procedure).</p>
<p>Because of this, the class order goes:</p>
<p>Clean Battery &gt; Clean Cell &gt; Clean Cycle &gt; Clean Data.</p>
<p>Instead of the usual</p>
<p>Clean Battery &gt; Clean Cycle &gt; Clean Data.</p>
<p>Each cell’s data is divided into different parts.
Experimentally, cells are cycled 10 times, then rest for one week, and then they
are cycled until a certain SOH. Usually, this data is divided into two parts
(he first 10 cycles then the rest period with the rest of the cycles), but this
may vary.</p>
<p>The classes for cleaning and storing the cleaned data already take these
different parts into account, merge them together and separate the different
cycles as necessary.</p>
<div class="section" id="classes-for-storing-the-raw-data">
<span id="raw-coin"></span><h2>Classes for storing the raw data<a class="headerlink" href="#classes-for-storing-the-raw-data" title="Permalink to this headline">¶</a></h2>
<dl class="py class">
<dt class="sig sig-object py" id="Coin_Classes.Dataset_Coin">
<em class="property"><span class="pre">class</span> </em><span class="sig-prename descclassname"><span class="pre">Coin_Classes.</span></span><span class="sig-name descname"><span class="pre">Dataset_Coin</span></span><span class="sig-paren">(</span><em class="sig-param"><span class="n"><span class="pre">battery_number</span></span></em><span class="sig-paren">)</span><a class="reference internal" href="../_modules/Coin_Classes.html#Dataset_Coin"><span class="viewcode-link"><span class="pre">[source]</span></span></a><a class="headerlink" href="#Coin_Classes.Dataset_Coin" title="Permalink to this definition">¶</a></dt>
<dd><p>Dataset for storing the raw coin-type battery data provided by M.
Tarascon.</p>
<p>Each dataset contains information for one set of experiments, which usually
contain 2 cells, the data of which are usually separated in two parts. The
first part contains the first 10 charge-discharge cycles, and the second
usually contains a rest period (of 1 week) and the rest of the
charge-discharge cycles. In a few cases, the rest period may show up in the
first part instead of the first, or in a third part.</p>
<p>The data for each experiment set is in a folder with the
respective battery number, in ‘/Datasets/Tarascon/Coins/Raw_Data’ . The
files are named as follows:
‘Cell’ + cell number + ‘_’ + part number + ‘.txt’</p>
<div class="admonition note">
<p class="admonition-title">Note</p>
<p>The console must already be in the correct directory upon calling of the
function (/Datasets/Tarascon/Coins/Raw_Data).</p>
</div>
<p>The data contains time [s], voltage [V], current [I] and capacity [A.h]
measurements. The capacity should, however, be normalized by the sodium mass,
which is given in the excel spreadsheet present in the same directory:
‘Information regarding cells.xlsx’. The code will automatically read it and
save all of the information contained.</p>
<dl class="field-list simple">
<dt class="field-odd">Parameters</dt>
<dd class="field-odd"><p><strong>battery_number</strong> (<em>int</em>) – The battery number, so the right directory can be opened</p>
</dd>
</dl>
<dl class="py attribute">
<dt class="sig sig-object py" id="Coin_Classes.Dataset_Coin.number">
<span class="sig-name descname"><span class="pre">number</span></span><a class="headerlink" href="#Coin_Classes.Dataset_Coin.number" title="Permalink to this definition">¶</a></dt>
<dd><p>The battery number informed upon initialization.</p>
<dl class="field-list simple">
<dt class="field-odd">Type</dt>
<dd class="field-odd"><p>int</p>
</dd>
</dl>
</dd></dl>

<dl class="py attribute">
<dt class="sig sig-object py" id="Coin_Classes.Dataset_Coin.Name">
<span class="sig-name descname"><span class="pre">Name</span></span><a class="headerlink" href="#Coin_Classes.Dataset_Coin.Name" title="Permalink to this definition">¶</a></dt>
<dd><p>The battery’s name: ‘B’+str(battery_number).zfill(4).
For battery_number = 1: Name = B0001; 12: Name = B0012 etc.</p>
<dl class="field-list simple">
<dt class="field-odd">Type</dt>
<dd class="field-odd"><p>str</p>
</dd>
</dl>
</dd></dl>

<dl class="py attribute">
<dt class="sig sig-object py" id="Coin_Classes.Dataset_Coin.electrode_batch">
<span class="sig-name descname"><span class="pre">electrode_batch</span></span><a class="headerlink" href="#Coin_Classes.Dataset_Coin.electrode_batch" title="Permalink to this definition">¶</a></dt>
<dd><p>Information about the thickness of the coating: ‘High Energy’ will
relate to thick coating, while ‘High Power’ will relate to thin.</p>
<dl class="field-list simple">
<dt class="field-odd">Type</dt>
<dd class="field-odd"><p>str</p>
</dd>
</dl>
</dd></dl>

<dl class="py attribute">
<dt class="sig sig-object py" id="Coin_Classes.Dataset_Coin.amb_T">
<span class="sig-name descname"><span class="pre">amb_T</span></span><a class="headerlink" href="#Coin_Classes.Dataset_Coin.amb_T" title="Permalink to this definition">¶</a></dt>
<dd><p>Temperature of the experiment. Usually (if not always) 55ºC.</p>
<dl class="field-list simple">
<dt class="field-odd">Type</dt>
<dd class="field-odd"><p>float</p>
</dd>
</dl>
</dd></dl>

<dl class="py attribute">
<dt class="sig sig-object py" id="Coin_Classes.Dataset_Coin.chemistry">
<span class="sig-name descname"><span class="pre">chemistry</span></span><a class="headerlink" href="#Coin_Classes.Dataset_Coin.chemistry" title="Permalink to this definition">¶</a></dt>
<dd><p>Information on the chemistry of the battery. The actual chemicals used
are hidden because of secrecy reasons.</p>
<dl class="field-list simple">
<dt class="field-odd">Type</dt>
<dd class="field-odd"><p>str</p>
</dd>
</dl>
</dd></dl>

<dl class="py attribute">
<dt class="sig sig-object py" id="Coin_Classes.Dataset_Coin.additive">
<span class="sig-name descname"><span class="pre">additive</span></span><a class="headerlink" href="#Coin_Classes.Dataset_Coin.additive" title="Permalink to this definition">¶</a></dt>
<dd><p>Information on the additives used (if any).</p>
<dl class="field-list simple">
<dt class="field-odd">Type</dt>
<dd class="field-odd"><p>str</p>
</dd>
</dl>
</dd></dl>

<dl class="py attribute">
<dt class="sig sig-object py" id="Coin_Classes.Dataset_Coin.NVPF_mass_1">
<span class="sig-name descname"><span class="pre">NVPF_mass_1</span></span><a class="headerlink" href="#Coin_Classes.Dataset_Coin.NVPF_mass_1" title="Permalink to this definition">¶</a></dt>
<dd><p>The mass [mg] of the NVPF electrode used for the first cell.</p>
<dl class="field-list simple">
<dt class="field-odd">Type</dt>
<dd class="field-odd"><p>float</p>
</dd>
</dl>
</dd></dl>

<dl class="py attribute">
<dt class="sig sig-object py" id="Coin_Classes.Dataset_Coin.NVPF_mass_2">
<span class="sig-name descname"><span class="pre">NVPF_mass_2</span></span><a class="headerlink" href="#Coin_Classes.Dataset_Coin.NVPF_mass_2" title="Permalink to this definition">¶</a></dt>
<dd><p>The mass [mg] of the NVPF electrode used for the second cell or ‘-‘ when
not applicable.</p>
<dl class="field-list simple">
<dt class="field-odd">Type</dt>
<dd class="field-odd"><p>float or str</p>
</dd>
</dl>
</dd></dl>

<dl class="py attribute">
<dt class="sig sig-object py" id="Coin_Classes.Dataset_Coin.cell">
<span class="sig-name descname"><span class="pre">cell</span></span><a class="headerlink" href="#Coin_Classes.Dataset_Coin.cell" title="Permalink to this definition">¶</a></dt>
<dd><p>A list of Coin_Cell objects containing information and data of the
specific cells.</p>
<dl class="field-list simple">
<dt class="field-odd">Type</dt>
<dd class="field-odd"><p>list(<a class="reference internal" href="#Coin_Classes.Coin_Cell" title="Coin_Classes.Coin_Cell">Coin_Cell</a>)</p>
</dd>
</dl>
</dd></dl>

</dd></dl>

<dl class="py class">
<dt class="sig sig-object py" id="Coin_Classes.Coin_Cell">
<em class="property"><span class="pre">class</span> </em><span class="sig-prename descclassname"><span class="pre">Coin_Classes.</span></span><span class="sig-name descname"><span class="pre">Coin_Cell</span></span><span class="sig-paren">(</span><em class="sig-param"><span class="n"><span class="pre">cell_file</span></span></em>, <em class="sig-param"><span class="n"><span class="pre">cell_number</span></span></em>, <em class="sig-param"><span class="n"><span class="pre">mass</span></span></em><span class="sig-paren">)</span><a class="reference internal" href="../_modules/Coin_Classes.html#Coin_Cell"><span class="viewcode-link"><span class="pre">[source]</span></span></a><a class="headerlink" href="#Coin_Classes.Coin_Cell" title="Permalink to this definition">¶</a></dt>
<dd><p>Class for storing the data for a single coin-like cell of M. Tarascon’s
data.</p>
<p>This follows from the Dataset_Coin class.</p>
<dl class="field-list simple">
<dt class="field-odd">Parameters</dt>
<dd class="field-odd"><ul class="simple">
<li><p><strong>cell_file</strong> (<em>str</em>) – The first half of the file’s name. The second half will be added later
according to the part number. The <code class="docutils literal notranslate"><span class="pre">cell_file</span></code> looks something like:
<em>‘Cell1_’</em>.</p></li>
<li><p><strong>cell_number</strong> (<em>int</em>) – The number of the cell.</p></li>
<li><p><strong>mass</strong> (<em>float</em>) – The mass of the cell [mg].</p></li>
</ul>
</dd>
</dl>
<dl class="py attribute">
<dt class="sig sig-object py" id="Coin_Classes.Coin_Cell.number">
<span class="sig-name descname"><span class="pre">number</span></span><a class="headerlink" href="#Coin_Classes.Coin_Cell.number" title="Permalink to this definition">¶</a></dt>
<dd><p>The cell number.</p>
<dl class="field-list simple">
<dt class="field-odd">Type</dt>
<dd class="field-odd"><p>int</p>
</dd>
</dl>
</dd></dl>

<dl class="py attribute">
<dt class="sig sig-object py" id="Coin_Classes.Coin_Cell.mass">
<span class="sig-name descname"><span class="pre">mass</span></span><a class="headerlink" href="#Coin_Classes.Coin_Cell.mass" title="Permalink to this definition">¶</a></dt>
<dd><p>The mass of the cell [mg].</p>
<dl class="field-list simple">
<dt class="field-odd">Type</dt>
<dd class="field-odd"><p>float</p>
</dd>
</dl>
</dd></dl>

<dl class="py attribute">
<dt class="sig sig-object py" id="Coin_Classes.Coin_Cell.part">
<span class="sig-name descname"><span class="pre">part</span></span><a class="headerlink" href="#Coin_Classes.Coin_Cell.part" title="Permalink to this definition">¶</a></dt>
<dd><p>A list of Coin_Part objects, containing the different parts of the data
(from 1 to 3 entries).</p>
<dl class="field-list simple">
<dt class="field-odd">Type</dt>
<dd class="field-odd"><p>list(<a class="reference internal" href="#Coin_Classes.Coin_Part" title="Coin_Classes.Coin_Part">Coin_Part</a>)</p>
</dd>
</dl>
</dd></dl>

</dd></dl>

<dl class="py class">
<dt class="sig sig-object py" id="Coin_Classes.Coin_Part">
<em class="property"><span class="pre">class</span> </em><span class="sig-prename descclassname"><span class="pre">Coin_Classes.</span></span><span class="sig-name descname"><span class="pre">Coin_Part</span></span><span class="sig-paren">(</span><em class="sig-param"><span class="n"><span class="pre">part_file</span></span></em><span class="sig-paren">)</span><a class="reference internal" href="../_modules/Coin_Classes.html#Coin_Part"><span class="viewcode-link"><span class="pre">[source]</span></span></a><a class="headerlink" href="#Coin_Classes.Coin_Part" title="Permalink to this definition">¶</a></dt>
<dd><p>Class for storing the data contained in each ‘.txt’ cell part file.</p>
<p>This class follows from the Coin_Cell class.</p>
<dl class="field-list simple">
<dt class="field-odd">Parameters</dt>
<dd class="field-odd"><p><strong>part_file</strong> (<em>str</em>) – The final file_name for the part file.</p>
</dd>
</dl>
<dl class="py attribute">
<dt class="sig sig-object py" id="Coin_Classes.Coin_Part.time">
<span class="sig-name descname"><span class="pre">time</span></span><a class="headerlink" href="#Coin_Classes.Coin_Part.time" title="Permalink to this definition">¶</a></dt>
<dd><p>The time stamps [s].</p>
<dl class="field-list simple">
<dt class="field-odd">Type</dt>
<dd class="field-odd"><p>np.ndarray</p>
</dd>
</dl>
</dd></dl>

<dl class="py attribute">
<dt class="sig sig-object py" id="Coin_Classes.Coin_Part.meas_v">
<span class="sig-name descname"><span class="pre">meas_v</span></span><a class="headerlink" href="#Coin_Classes.Coin_Part.meas_v" title="Permalink to this definition">¶</a></dt>
<dd><p>The measured voltage [V].</p>
<dl class="field-list simple">
<dt class="field-odd">Type</dt>
<dd class="field-odd"><p>np.ndarray</p>
</dd>
</dl>
</dd></dl>

<dl class="py attribute">
<dt class="sig sig-object py" id="Coin_Classes.Coin_Part.meas_i">
<span class="sig-name descname"><span class="pre">meas_i</span></span><a class="headerlink" href="#Coin_Classes.Coin_Part.meas_i" title="Permalink to this definition">¶</a></dt>
<dd><p>The measured current [A].</p>
<dl class="field-list simple">
<dt class="field-odd">Type</dt>
<dd class="field-odd"><p>np.ndarray</p>
</dd>
</dl>
</dd></dl>

<dl class="py attribute">
<dt class="sig sig-object py" id="Coin_Classes.Coin_Part.meas_q">
<span class="sig-name descname"><span class="pre">meas_q</span></span><a class="headerlink" href="#Coin_Classes.Coin_Part.meas_q" title="Permalink to this definition">¶</a></dt>
<dd><p>The measured capacity [A.h].</p>
<dl class="field-list simple">
<dt class="field-odd">Type</dt>
<dd class="field-odd"><p>np.ndarray</p>
</dd>
</dl>
</dd></dl>

</dd></dl>

</div>
<div class="section" id="classes-for-cleaning-and-storing-cleaned-data">
<span id="clean-coin"></span><h2>Classes for cleaning and storing cleaned data<a class="headerlink" href="#classes-for-cleaning-and-storing-cleaned-data" title="Permalink to this headline">¶</a></h2>
<dl class="py class">
<dt class="sig sig-object py" id="Coin_Classes.Clean_Coin_Battery">
<em class="property"><span class="pre">class</span> </em><span class="sig-prename descclassname"><span class="pre">Coin_Classes.</span></span><span class="sig-name descname"><span class="pre">Clean_Coin_Battery</span></span><span class="sig-paren">(</span><em class="sig-param"><span class="n"><span class="pre">Battery</span></span></em>, <em class="sig-param"><span class="n"><span class="pre">threshold</span></span><span class="o"><span class="pre">=</span></span><span class="default_value"><span class="pre">0.1</span></span></em><span class="sig-paren">)</span><a class="reference internal" href="../_modules/Coin_Classes.html#Clean_Coin_Battery"><span class="viewcode-link"><span class="pre">[source]</span></span></a><a class="headerlink" href="#Coin_Classes.Clean_Coin_Battery" title="Permalink to this definition">¶</a></dt>
<dd><p>Class for storing the cleaned data from a coin-type battery provided by
M. Tarascon.</p>
<p>This will take a Dataset_Coin object, save its cells in the same way
(attribute cell, which is a list of <code class="docutils literal notranslate"><span class="pre">Clean_Cell</span></code> objects this time) but
separate the cycles contained in each part in different objects
(specifically <code class="docutils literal notranslate"><span class="pre">Coin_Cycle</span></code> objects) - for more information see the
documentation for the <code class="docutils literal notranslate"><span class="pre">Clean_Cell</span></code> class. As in the <code class="docutils literal notranslate"><span class="pre">Clean_Battery</span></code>
class from <cite>Nasa_Classes.py</cite>, the cycles are then separated into couples of
charge and discharge cycles and saved in attribute <code class="docutils literal notranslate"><span class="pre">cycle_couples</span></code></p>
<div class="admonition note">
<p class="admonition-title">Note</p>
<p>Many attributes are directly inherited from the <code class="docutils literal notranslate"><span class="pre">Dataset_Coin</span></code> class
given as input to the initialization. Because of this, they aren’t
described in this documentation, only in the <code class="docutils literal notranslate"><span class="pre">Dataset_Coin</span></code>’s. These
attributes are: <cite>Name</cite>, <cite>number</cite>, <cite>electrode_batch</cite>, <cite>amb_T</cite>,
<cite>chemistry</cite>, <cite>additive</cite>, <cite>NVPF_mass_1</cite>, <cite>NVPF_mass_2</cite>.</p>
</div>
<dl class="field-list simple">
<dt class="field-odd">Parameters</dt>
<dd class="field-odd"><ul class="simple">
<li><p><strong>Battery</strong> (<a class="reference internal" href="#Coin_Classes.Dataset_Coin" title="Coin_Classes.Dataset_Coin"><em>Dataset_Coin</em></a>) – The Dataset_Coin object from which we’ll be extracting and treating the
data.</p></li>
<li><p><strong>threshold</strong> (<em>float</em><em>, </em><em>default = 0.1</em>) – The minimum value of capacity [A.h, before normalization per mass] a
cycle must have for it to be considered as relevant. Otherwise, the
cycle is discarded.</p></li>
</ul>
</dd>
</dl>
<dl class="py attribute">
<dt class="sig sig-object py" id="Coin_Classes.Clean_Coin_Battery.cell">
<span class="sig-name descname"><span class="pre">cell</span></span><a class="headerlink" href="#Coin_Classes.Clean_Coin_Battery.cell" title="Permalink to this definition">¶</a></dt>
<dd><p>List with the Clean_Cell objects containing information about each cell.</p>
<dl class="field-list simple">
<dt class="field-odd">Type</dt>
<dd class="field-odd"><p>list(<a class="reference internal" href="#Coin_Classes.Clean_Cell" title="Coin_Classes.Clean_Cell">Clean_Cell</a>)</p>
</dd>
</dl>
</dd></dl>

</dd></dl>

<dl class="py class">
<dt class="sig sig-object py" id="Coin_Classes.Clean_Cell">
<em class="property"><span class="pre">class</span> </em><span class="sig-prename descclassname"><span class="pre">Coin_Classes.</span></span><span class="sig-name descname"><span class="pre">Clean_Cell</span></span><span class="sig-paren">(</span><em class="sig-param"><span class="n"><span class="pre">cell</span></span></em>, <em class="sig-param"><span class="n"><span class="pre">Name</span></span></em>, <em class="sig-param"><span class="n"><span class="pre">amb_T</span></span><span class="o"><span class="pre">=</span></span><span class="default_value"><span class="pre">55.0</span></span></em>, <em class="sig-param"><span class="n"><span class="pre">threshold</span></span><span class="o"><span class="pre">=</span></span><span class="default_value"><span class="pre">0.1</span></span></em><span class="sig-paren">)</span><a class="reference internal" href="../_modules/Coin_Classes.html#Clean_Cell"><span class="viewcode-link"><span class="pre">[source]</span></span></a><a class="headerlink" href="#Coin_Classes.Clean_Cell" title="Permalink to this definition">¶</a></dt>
<dd><p>Class that stores the cleaned data for each coin-type cell.</p>
<p>This follows from the <code class="docutils literal notranslate"><span class="pre">Clean_Coin_Battery</span></code> class.</p>
<div class="admonition note">
<p class="admonition-title">Note</p>
<p>Some of this class’s attributes are directly inherited from the
<code class="docutils literal notranslate"><span class="pre">Coin_Cell</span></code> class which is used as a base for the cleaning and thus
won’t be cited in this documentation. These attributes are: <cite>number</cite>,
<cite>mass</cite>.</p>
</div>
<dl class="field-list simple">
<dt class="field-odd">Parameters</dt>
<dd class="field-odd"><ul class="simple">
<li><p><strong>cell</strong> (<a class="reference internal" href="#Coin_Classes.Coin_Cell" title="Coin_Classes.Coin_Cell"><em>Coin_Cell</em></a>) – The Coin_Cell object used as a base.</p></li>
<li><p><strong>Name</strong> (<em>str</em>) – The battery’s name. This isn’t a intrinsically necessary information to
have in this class, but it is defined because dataset creation classes
may call for a battery’s <code class="docutils literal notranslate"><span class="pre">Name</span></code> attribute, so this avoids unnecessary
errors/warnings.</p></li>
<li><p><strong>amb_T</strong> (<em>float</em><em>, </em><em>default = 55.</em>) – The ambient temperature where the experiments where held.</p></li>
<li><p><strong>threshold</strong> (<em>float</em><em>, </em><em>default = 0.1</em>) – The minimum value of capacity [A.h, before normalization per mass] a
cycle must have for it to be considered as relevant. Otherwise, the
cycle is discarded.</p></li>
</ul>
</dd>
</dl>
<dl class="py attribute">
<dt class="sig sig-object py" id="Coin_Classes.Clean_Cell.separation">
<span class="sig-name descname"><span class="pre">separation</span></span><a class="headerlink" href="#Coin_Classes.Clean_Cell.separation" title="Permalink to this definition">¶</a></dt>
<dd><p>The cycle number that separates the first part of the data from the
second. This is mostly for documenting than anything.</p>
<dl class="field-list simple">
<dt class="field-odd">Type</dt>
<dd class="field-odd"><p>int</p>
</dd>
</dl>
</dd></dl>

<dl class="py attribute">
<dt class="sig sig-object py" id="Coin_Classes.Clean_Cell.cycle">
<span class="sig-name descname"><span class="pre">cycle</span></span><a class="headerlink" href="#Coin_Classes.Clean_Cell.cycle" title="Permalink to this definition">¶</a></dt>
<dd><p>A list with all of the tested cycles. See <code class="docutils literal notranslate"><span class="pre">Coin_Cycle</span></code> and
<code class="docutils literal notranslate"><span class="pre">clean_coin_cycle</span></code> (in <cite>Cleaning.py</cite>) documentations for details on
the class structure and on how the cycles are treated.</p>
<dl class="field-list simple">
<dt class="field-odd">Type</dt>
<dd class="field-odd"><p>list[<a class="reference internal" href="#Coin_Classes.Coin_Cycle" title="Coin_Classes.Coin_Cycle">Coin_Cycle</a>]</p>
</dd>
</dl>
</dd></dl>

<dl class="py attribute">
<dt class="sig sig-object py" id="Coin_Classes.Clean_Cell.raw_couples">
<span class="sig-name descname"><span class="pre">raw_couples</span></span><a class="headerlink" href="#Coin_Classes.Clean_Cell.raw_couples" title="Permalink to this definition">¶</a></dt>
<dd><p>The number of the charge and discharge cycles in each couple.
Example:
self.couples[k] = (charge cycle number, discharge cycle number)</p>
<dl class="field-list simple">
<dt class="field-odd">Type</dt>
<dd class="field-odd"><p>list[tuple(int)]</p>
</dd>
</dl>
</dd></dl>

<dl class="py attribute">
<dt class="sig sig-object py" id="Coin_Classes.Clean_Cell.couples">
<span class="sig-name descname"><span class="pre">couples</span></span><a class="headerlink" href="#Coin_Classes.Clean_Cell.couples" title="Permalink to this definition">¶</a></dt>
<dd><p>Exactly like the <code class="docutils literal notranslate"><span class="pre">raw_couples</span></code> attribute, but without the entries that
are judged as abnormal or that have missing datapoints or that are too
short etc.</p>
<dl class="field-list simple">
<dt class="field-odd">Type</dt>
<dd class="field-odd"><p>list[tuple(int)]</p>
</dd>
</dl>
</dd></dl>

<dl class="py attribute">
<dt class="sig sig-object py" id="Coin_Classes.Clean_Cell.cycle_couple">
<span class="sig-name descname"><span class="pre">cycle_couple</span></span><a class="headerlink" href="#Coin_Classes.Clean_Cell.cycle_couple" title="Permalink to this definition">¶</a></dt>
<dd><p>The Coin_Cycle objects corresponding to each couple.
self.cycle_couple[k] = (charge Coin_Cycle, discharge Coin_Cycle)</p>
<dl class="field-list simple">
<dt class="field-odd">Type</dt>
<dd class="field-odd"><p>list[tuple(<a class="reference internal" href="NASA.html#Nasa_Classes.Clean_Cycle" title="Nasa_Classes.Clean_Cycle">Clean_Cycle</a>)]</p>
</dd>
</dl>
</dd></dl>

<dl class="py attribute">
<dt class="sig sig-object py" id="Coin_Classes.Clean_Cell.capacity_curve">
<span class="sig-name descname"><span class="pre">capacity_curve</span></span><a class="headerlink" href="#Coin_Classes.Clean_Cell.capacity_curve" title="Permalink to this definition">¶</a></dt>
<dd><p>Array with the capacity value for each discharge cycle. The first
column corresponds to the cycle’s number and the second one to the
capacity value (normalized by the electrode’s mass) [A.h/g].</p>
<dl class="field-list simple">
<dt class="field-odd">Type</dt>
<dd class="field-odd"><p>np.ndarray</p>
</dd>
</dl>
</dd></dl>

<dl class="py attribute">
<dt class="sig sig-object py" id="Coin_Classes.Clean_Cell.C_rate">
<span class="sig-name descname"><span class="pre">C_rate</span></span><a class="headerlink" href="#Coin_Classes.Clean_Cell.C_rate" title="Permalink to this definition">¶</a></dt>
<dd><p>The C rate associated to the battery for nondimensionning the
current [A].</p>
<dl class="field-list simple">
<dt class="field-odd">Type</dt>
<dd class="field-odd"><p>float</p>
</dd>
</dl>
</dd></dl>

<dl class="py attribute">
<dt class="sig sig-object py" id="Coin_Classes.Clean_Cell.Q_nominal">
<span class="sig-name descname"><span class="pre">Q_nominal</span></span><a class="headerlink" href="#Coin_Classes.Clean_Cell.Q_nominal" title="Permalink to this definition">¶</a></dt>
<dd><p>The battery’s nominal capacity (for nondimensionning the SOH) [A.h].</p>
<dl class="field-list simple">
<dt class="field-odd">Type</dt>
<dd class="field-odd"><p>float</p>
</dd>
</dl>
</dd></dl>

<dl class="py attribute">
<dt class="sig sig-object py" id="Coin_Classes.Clean_Cell.V_nominal">
<span class="sig-name descname"><span class="pre">V_nominal</span></span><a class="headerlink" href="#Coin_Classes.Clean_Cell.V_nominal" title="Permalink to this definition">¶</a></dt>
<dd><p>The battery’s nominal voltage (for nondimensionning the voltage) [V].</p>
<dl class="field-list simple">
<dt class="field-odd">Type</dt>
<dd class="field-odd"><p>float</p>
</dd>
</dl>
</dd></dl>

<dl class="py method">
<dt class="sig sig-object py" id="Coin_Classes.Clean_Cell.separate_coin_cycles">
<span class="sig-name descname"><span class="pre">separate_coin_cycles</span></span><span class="sig-paren">(</span><em class="sig-param"><span class="n"><span class="pre">time</span></span></em>, <em class="sig-param"><span class="n"><span class="pre">data</span></span></em>, <em class="sig-param"><span class="n"><span class="pre">amb_T</span></span><span class="o"><span class="pre">=</span></span><span class="default_value"><span class="pre">55.0</span></span></em>, <em class="sig-param"><span class="n"><span class="pre">cycle_number</span></span><span class="o"><span class="pre">=</span></span><span class="default_value"><span class="pre">0</span></span></em>, <em class="sig-param"><span class="n"><span class="pre">last_time</span></span><span class="o"><span class="pre">=</span></span><span class="default_value"><span class="pre">0</span></span></em>, <em class="sig-param"><span class="n"><span class="pre">min_len</span></span><span class="o"><span class="pre">=</span></span><span class="default_value"><span class="pre">50</span></span></em><span class="sig-paren">)</span><a class="reference internal" href="../_modules/Coin_Classes.html#Clean_Cell.separate_coin_cycles"><span class="viewcode-link"><span class="pre">[source]</span></span></a><a class="headerlink" href="#Coin_Classes.Clean_Cell.separate_coin_cycles" title="Permalink to this definition">¶</a></dt>
<dd><p>Function for separating the cycles from the <code class="docutils literal notranslate"><span class="pre">Coin_Part</span></code>’s raw data.</p>
<p>The dataset’s raw data comes with all of the cycles concatenated.
This function will separate them from each other and add them to
<code class="docutils literal notranslate"><span class="pre">Clean_Cell</span></code>’s <code class="docutils literal notranslate"><span class="pre">cycle</span></code> attribute (list of <code class="docutils literal notranslate"><span class="pre">Coin_Cycle</span></code> objects).</p>
<p>The function starts by seeing when the first cycle starts (Current ≠ 0).
In some cases, the file being read corresponds solely to the rest
period, in these cases the current = 0 all the way so the function
prints “I = 0” and quits by returning <code class="docutils literal notranslate"><span class="pre">None</span></code>.</p>
<p>A <cite>while</cite> loop is then used to check when the current changes sign
(switching from charge, I &gt; 0, to discharge, I &lt; 0, and vice-versa).
The index of the following cycle is saved in <code class="docutils literal notranslate"><span class="pre">final_idx</span></code>. Only data
before <code class="docutils literal notranslate"><span class="pre">final_idx</span></code> is then treated for the current cycle.
If the current no longer changes sign (the last cycle is reached), an
<code class="docutils literal notranslate"><span class="pre">IndexError</span></code> is raised, which leads the <cite>try</cite> statement another way
in order to later stop the loop.</p>
<p>Knowing the index window of the cycle, a moving window outlier detection
is done through <cite>pandas</cite>’s <code class="docutils literal notranslate"><span class="pre">rolling(...)</span></code> method. The window and
threshold were <em>hand-picked</em> to eliminate big outliers and avoid
eliminating curve detail. A interquantile range method was also tested
but yielded worse results.</p>
<p>Finally, if the last few points of the cycle have <cite>Current = 0</cite>, these
points are taken away. This happens in some cases because the only way
one cycle is separated from the other is by checking when the current
changes sign.</p>
<p>Finally, if the cycle is too short (&lt; <code class="docutils literal notranslate"><span class="pre">min_len</span></code>) it is discarded (not
added to the <code class="docutils literal notranslate"><span class="pre">self.cycle</span></code> list.</p>
<dl class="field-list simple">
<dt class="field-odd">Parameters</dt>
<dd class="field-odd"><ul class="simple">
<li><p><strong>time</strong> (<em>np.ndarray</em>) – Time stamps [s].</p></li>
<li><p><strong>data</strong> (<em>np.ndarray</em>) – The rest of the data (voltage [V], current [A] and capacity [A.h])
concatenated in one array (features in columns, axis=1).</p></li>
<li><p><strong>amb_T</strong> (<em>float</em><em>, </em><em>default = 55.</em>) – The ambient temperature [ºC].</p></li>
<li><p><strong>cycle_number</strong> (<em>int</em><em>, </em><em>default = 0</em>) – The cycle number.</p></li>
<li><p><strong>last_time</strong> (<em>float</em><em>, </em><em>default = 0</em>) – <p>Last time stamp from the last battery <em>part</em> cleaned.</p>
<p>In some cases, the time stamps from one <em>part</em> to the next are reset
to zero (example: from the <em>part</em> before the rest and the one right
after).</p>
<p>Usually only ∆t is important for analyses, but having absolute
information in better and might come in handy in the future.</p>
</p></li>
<li><p><strong>min_len</strong> (<em>int</em><em>, </em><em>default = 50</em>) – The minimum length (number of points) the cycle must have for it to
be considered relevant.</p></li>
</ul>
</dd>
</dl>
</dd></dl>

</dd></dl>

<dl class="py class">
<dt class="sig sig-object py" id="Coin_Classes.Coin_Cycle">
<em class="property"><span class="pre">class</span> </em><span class="sig-prename descclassname"><span class="pre">Coin_Classes.</span></span><span class="sig-name descname"><span class="pre">Coin_Cycle</span></span><span class="sig-paren">(</span><em class="sig-param"><span class="n"><span class="pre">data</span></span></em>, <em class="sig-param"><span class="n"><span class="pre">number</span></span></em>, <em class="sig-param"><span class="n"><span class="pre">mass</span></span></em>, <em class="sig-param"><span class="n"><span class="pre">amb_T</span></span><span class="o"><span class="pre">=</span></span><span class="default_value"><span class="pre">55.0</span></span></em><span class="sig-paren">)</span><a class="reference internal" href="../_modules/Coin_Classes.html#Coin_Cycle"><span class="viewcode-link"><span class="pre">[source]</span></span></a><a class="headerlink" href="#Coin_Classes.Coin_Cycle" title="Permalink to this definition">¶</a></dt>
<dd><p>Class for storing information about each cycle of M. Tarascon’s coin
battery dataset.</p>
<dl class="field-list simple">
<dt class="field-odd">Parameters</dt>
<dd class="field-odd"><ul class="simple">
<li><p><strong>data</strong> (<em>np.ndarray</em>) – Array containing all of the important data (voltage [V], current [A] and
capacity [A.h]) concatenated in one array (features in columns, axis=1).</p></li>
<li><p><strong>number</strong> (<em>int</em>) – The cycle number.</p></li>
<li><p><strong>mass</strong> (<em>float</em>) – The cell’s mass [mg].</p></li>
<li><p><strong>amb_T</strong> (<em>float</em><em>, </em><em>default = 55.</em>) – The ambient temperature where the experiments where held.</p></li>
</ul>
</dd>
</dl>
<dl class="py attribute">
<dt class="sig sig-object py" id="Coin_Classes.Coin_Cycle.number">
<span class="sig-name descname"><span class="pre">number</span></span><a class="headerlink" href="#Coin_Classes.Coin_Cycle.number" title="Permalink to this definition">¶</a></dt>
<dd><p>The cycle number</p>
<dl class="field-list simple">
<dt class="field-odd">Type</dt>
<dd class="field-odd"><p>int</p>
</dd>
</dl>
</dd></dl>

<dl class="py attribute">
<dt class="sig sig-object py" id="Coin_Classes.Coin_Cycle.amb_T">
<span class="sig-name descname"><span class="pre">amb_T</span></span><a class="headerlink" href="#Coin_Classes.Coin_Cycle.amb_T" title="Permalink to this definition">¶</a></dt>
<dd><p>The ambient temperature where the experiments where held.</p>
<dl class="field-list simple">
<dt class="field-odd">Type</dt>
<dd class="field-odd"><p>float</p>
</dd>
</dl>
</dd></dl>

<dl class="py attribute">
<dt class="sig sig-object py" id="Coin_Classes.Coin_Cycle.data">
<span class="sig-name descname"><span class="pre">data</span></span><a class="headerlink" href="#Coin_Classes.Coin_Cycle.data" title="Permalink to this definition">¶</a></dt>
<dd><p>Class with the actual information.</p>
<dl class="field-list simple">
<dt class="field-odd">Type</dt>
<dd class="field-odd"><p><a class="reference internal" href="#Coin_Classes.Coin_Data" title="Coin_Classes.Coin_Data">Coin_Data</a></p>
</dd>
</dl>
</dd></dl>

</dd></dl>

<dl class="py class">
<dt class="sig sig-object py" id="Coin_Classes.Coin_Data">
<em class="property"><span class="pre">class</span> </em><span class="sig-prename descclassname"><span class="pre">Coin_Classes.</span></span><span class="sig-name descname"><span class="pre">Coin_Data</span></span><span class="sig-paren">(</span><em class="sig-param"><span class="n"><span class="pre">data</span></span></em>, <em class="sig-param"><span class="n"><span class="pre">mass</span></span></em><span class="sig-paren">)</span><a class="reference internal" href="../_modules/Coin_Classes.html#Coin_Data"><span class="viewcode-link"><span class="pre">[source]</span></span></a><a class="headerlink" href="#Coin_Classes.Coin_Data" title="Permalink to this definition">¶</a></dt>
<dd><p>Class for storing information about each cycle of M. Tarascon’s coin
battery dataset.</p>
<dl class="field-list simple">
<dt class="field-odd">Parameters</dt>
<dd class="field-odd"><ul class="simple">
<li><p><strong>data</strong> (<em>np.ndarray</em>) – Array containing all of the important data (voltage [V], current [A] and
capacity [A.h]) concatenated in one array (features in columns, axis=1).</p></li>
<li><p><strong>mass</strong> (<em>float</em>) – The cell’s mass [mg].</p></li>
</ul>
</dd>
</dl>
<dl class="py attribute">
<dt class="sig sig-object py" id="Coin_Classes.Coin_Data.meas_v">
<span class="sig-name descname"><span class="pre">meas_v</span></span><a class="headerlink" href="#Coin_Classes.Coin_Data.meas_v" title="Permalink to this definition">¶</a></dt>
<dd><p>Battery terminal voltage [V].</p>
<dl class="field-list simple">
<dt class="field-odd">Type</dt>
<dd class="field-odd"><p>ndarray[floats]</p>
</dd>
</dl>
</dd></dl>

<dl class="py attribute">
<dt class="sig sig-object py" id="Coin_Classes.Coin_Data.meas_i">
<span class="sig-name descname"><span class="pre">meas_i</span></span><a class="headerlink" href="#Coin_Classes.Coin_Data.meas_i" title="Permalink to this definition">¶</a></dt>
<dd><p>Battery output current [A].</p>
<dl class="field-list simple">
<dt class="field-odd">Type</dt>
<dd class="field-odd"><p>ndarray[floats]</p>
</dd>
</dl>
</dd></dl>

<dl class="py attribute">
<dt class="sig sig-object py" id="Coin_Classes.Coin_Data.meas_q">
<span class="sig-name descname"><span class="pre">meas_q</span></span><a class="headerlink" href="#Coin_Classes.Coin_Data.meas_q" title="Permalink to this definition">¶</a></dt>
<dd><p>Battery capacity variatioon over time, normalized by the mass) [A.h/mg].</p>
<dl class="field-list simple">
<dt class="field-odd">Type</dt>
<dd class="field-odd"><p>ndarray[floats]</p>
</dd>
</dl>
</dd></dl>

<dl class="py attribute">
<dt class="sig sig-object py" id="Coin_Classes.Coin_Data.time">
<span class="sig-name descname"><span class="pre">time</span></span><a class="headerlink" href="#Coin_Classes.Coin_Data.time" title="Permalink to this definition">¶</a></dt>
<dd><p>Time vector for the cycle [s].</p>
<dl class="field-list simple">
<dt class="field-odd">Type</dt>
<dd class="field-odd"><p>ndarray[floats]</p>
</dd>
</dl>
</dd></dl>

<dl class="py attribute">
<dt class="sig sig-object py" id="Coin_Classes.Coin_Data.capacity">
<span class="sig-name descname"><span class="pre">capacity</span></span><a class="headerlink" href="#Coin_Classes.Coin_Data.capacity" title="Permalink to this definition">¶</a></dt>
<dd><p>The capacity value normalized by the mass[A.h/mg].</p>
<dl class="field-list simple">
<dt class="field-odd">Type</dt>
<dd class="field-odd"><p>float</p>
</dd>
</dl>
</dd></dl>

</dd></dl>

</div>
</div>


              </div>
              
              
              <div class='prev-next-bottom'>
                
    <a class='left-prev' id="prev-link" href="MIT.html" title="previous page">MIT dataset</a>
    <a class='right-next' id="next-link" href="Cleaning.html" title="next page">Treatment functions</a>

              </div>
              
          </main>
          

      </div>
    </div>
  
  <script src="../_static/js/index.1c5a1a01449ed65a7b51.js"></script>

  <footer class="footer mt-5 mt-md-0">
  <div class="container">
    
    <div class="footer-item">
      <p class="copyright">
    &copy; Copyright 2021, Antonio Rocha Azevedo.<br/>
</p>
    </div>
    
    <div class="footer-item">
      <p class="sphinx-version">
Created using <a href="http://sphinx-doc.org/">Sphinx</a> 4.0.2.<br/>
</p>
    </div>
    
  </div>
</footer>
  </body>
</html>